import java.io.* ;

public final class CombinatorI extends SKAtom
{
    public final static CombinatorI unique = new CombinatorI() ;

    private CombinatorI() {} 

    private final static SKApplication KI = new SKApplication(CombinatorK.unique,CombinatorI.unique) ;

    public final SKTerm abstractPlus(SKSymbol x)
    {
	return KI ;
    }

    public final SKTerm abstractPlusPlus(SKSymbol x)
    {
	return KI ;
    }

    public final SKTerm abstractPlusPlusPlus(SKSymbol x)
    {
	return KI ;
    }

    public final SKTerm abstractPlusPlusPlusPlus(SKSymbol x)
    {
	return KI ;
    }

    public final void writeTo(Writer writer)
	throws Exception
    {
	writer.write("I") ;
    }

    // VERSION = 0 : more complex but better replacement
    // VERSION = 1 : sufficient but less replacment
    public static final int VERSION = 0 ;

    public boolean operate()
    {
	SKTerm iArgument =  SKMachine.skRegister.argument ;

	if (SKMachine.skStack.geThanOne()) {

	    if (VERSION == 0) {

		// (I M N) replaced by (M N)
		SKApplication imn = SKMachine.skStack.pop() ;
		imn.function = iArgument ;
		
		if (iArgument.isApplication()) {
		    // I (P Q) replaced with (P Q) 
		    iArgument.replace(SKMachine.skRegister) ;	        
		}
		
		SKMachine.skRegister = imn ;
	    }

	    if (VERSION == 1) {
		(SKMachine.skRegister = SKMachine.skStack.pop()).function = iArgument ;
	    }

	    SKMachine.reductionCount++ ;
	    return true ;
	}

	if (iArgument.isApplication()) {

	    // I (P Q) replaced with (P Q) 
	    iArgument.replace(SKMachine.skRegister) ;

	    SKMachine.reductionCount++ ;
	    return true ;
	}

	return false ;
    }

    public boolean isI()
    {
	return true ;
    }

}
