%%

%byaccj

%class SKLexer 
%public
%final
%line

%{
  /* store a reference to the parser object */
  private SKParser skParser;

  /* constructor taking an additional parser object */
  public SKLexer(java.io.Reader r, SKParser skParser) {
    this(r);
    this.skParser = skParser;
  }

  public final int getLine()
  {
    return yyline ;
  }

  private final static boolean DEBUG = false ; 
%}

%%

"S" { if (DEBUG) System.out.println("S") ; return skParser.S ; }
"K" { if (DEBUG) System.out.println("K") ; return skParser.K ; }
"I" { if (DEBUG) System.out.println("I") ; return skParser.I ; }
"#" { if (DEBUG) System.out.println("#") ; return skParser.Dieze ; }

"@" { if (DEBUG) System.out.println("#") ; return skParser.Arobase ; }

"C*" { if (DEBUG) System.out.println("C*") ; return skParser.SYMBOL ; }
"K*" { if (DEBUG) System.out.println("K*") ; return skParser.SYMBOL ; }

"#DEF" { if (DEBUG) System.out.println("#DEF") ; return skParser.LET ; }
"="    { if (DEBUG) System.out.println("=") ; return skParser.EGAL ; }
";;"   { if (DEBUG) System.out.println(";;") ; return skParser.DOUBLE_POINT_VIRGULE ; }

"#UNDEF" { if (DEBUG) System.out.println("#UNDEF") ; return skParser.UNDEF ; }

"[" { if (DEBUG) System.out.println("[") ; return skParser.LEFT_BRACKET ; }
"]" { if (DEBUG) System.out.println("]") ; return skParser.RIGHT_BRACKET ; }
"." { if (DEBUG) System.out.println(".") ; return skParser.DOT ; }
"," { if (DEBUG) System.out.println(",") ; return skParser.COMMA ; }

"(" { if (DEBUG) System.out.println("(") ; return skParser.LEFT_PAREN ; }
")" { if (DEBUG) System.out.println(")") ; return skParser.RIGHT_PAREN ; }

"+"  { if (DEBUG) System.out.println("+")  ; return skParser.SYMBOL; }
"-"  { if (DEBUG) System.out.println("-")  ; return skParser.SYMBOL; }
"*"  { if (DEBUG) System.out.println("*")  ; return skParser.SYMBOL; }
"/"  { if (DEBUG) System.out.println("/")  ; return skParser.SYMBOL; }
"%"  { if (DEBUG) System.out.println("%")  ; return skParser.SYMBOL; }
"=0" { if (DEBUG) System.out.println("=0") ; return skParser.SYMBOL; }
"==" { if (DEBUG) System.out.println("==") ; return skParser.SYMBOL; }
"!=" { if (DEBUG) System.out.println("!=") ; return skParser.SYMBOL; }
"<=" { if (DEBUG) System.out.println("<=") ; return skParser.SYMBOL; }
"<"  { if (DEBUG) System.out.println("<")  ; return skParser.SYMBOL; }
">=" { if (DEBUG) System.out.println(">=") ; return skParser.SYMBOL; }
">"  { if (DEBUG) System.out.println(">")  ; return skParser.SYMBOL; }
"1+" { if (DEBUG) System.out.println("1+") ; return skParser.SYMBOL; }
"1-" { if (DEBUG) System.out.println("1-") ; return skParser.SYMBOL; }
"0"  { if (DEBUG) System.out.println("0")  ; return skParser.SYMBOL; }

"\\+"    { if (DEBUG) System.out.println("\\+") ;    return skParser.LAMBDA_PLUS ; }
"\\++"   { if (DEBUG) System.out.println("\\++") ;   return skParser.LAMBDA_PLUS_PLUS ; }
"\\+++"  { if (DEBUG) System.out.println("\\+++") ;  return skParser.LAMBDA_PLUS_PLUS_PLUS ; }
"\\++++" { if (DEBUG) System.out.println("\\++++") ; return skParser.LAMBDA_PLUS_PLUS_PLUS_PLUS ; }

[1-9][0-9]* { if (DEBUG) System.out.println(yytext()) ; return skParser.INTEGER ; }

[a-zA-Z][a-zA-Z0-9]* { if (DEBUG) System.out.println(yytext()) ; return skParser.SYMBOL ; }

[\ \b\t\n]+  { if (DEBUG) System.out.println("<space>") ; }

"//"[^\n]*\n   { if (DEBUG) System.out.println("<comment>") ; }
