import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

public class SKCommandEditor extends JPanel
{
    private final SKFrame            skFrame ;
    private final JLabel             witnessLabel ;
    private final SKCommandTextField skCommandTextField ;
    private final SKButton           clearButton ;
    private final SKButton           headReductionButton ;
    private final SKButton           fullReductionButton ;
    private final SKButton           oneStepButton ;

    public SKCommandEditor(SKFrame skFrame)
    {
	setBorder(BorderFactory.createTitledBorder("Expression")) ;

	setLayout(new BorderLayout()) ;
	
	add(witnessLabel = new JLabel(),BorderLayout.WEST) ;

	add(skCommandTextField = new SKCommandTextField(this),BorderLayout.CENTER) ;

	add(clearButton = new SKButton("Clear",
				       new ActionListener() {
					   public void actionPerformed(ActionEvent e)
					   {
					       skCommandTextField.setText("") ;
					   }}),BorderLayout.EAST) ;
	
	{
	    JPanel buttonsPanel = new JPanel() ;
	    buttonsPanel.setLayout(new GridLayout(1,5)) ;
	    buttonsPanel.add(new JLabel()) ;
	    buttonsPanel.add(headReductionButton = new SKButton("Head reduction",
								new ActionListener() {
								    public void actionPerformed(ActionEvent e)
								    {
									skCommandTextField.historyShift() ;
									headReduction() ;
								    }})) ;
	    buttonsPanel.add(fullReductionButton = new SKButton("Full reduction",
								new ActionListener() {
								    public void actionPerformed(ActionEvent e)
								    {
									skCommandTextField.historyShift() ;
									fullReduction() ;
								    }})) ;
	    buttonsPanel.add(oneStepButton = new SKButton("One head redex",
							  new ActionListener() {
							      public void actionPerformed(ActionEvent e)
							      {
								  skCommandTextField.historyShift() ;
								  oneStepReduction() ;
							      }})) ;
	    buttonsPanel.add(new JLabel()) ;
	    add(buttonsPanel,BorderLayout.SOUTH) ;
	}


	this.skFrame = skFrame ;
    }

    public final void setRunning(boolean running)
    {
	boolean notRunning = !running ;

	skCommandTextField  .setEnabled(notRunning) ;
	clearButton         .setEnabled(notRunning) ;
	headReductionButton .setEnabled(notRunning) ;
	fullReductionButton .setEnabled(notRunning) ;
	oneStepButton       .setEnabled(notRunning) ;

	witnessLabel.setIcon((running)?SKUtils.dynamicIcon:SKUtils.staticIcon) ;

	if (notRunning)
	    skCommandTextField.requestFocusInWindow() ;
    }

    public final void headReduction()
    {
	SKWorker.run(skFrame,skCommandTextField.getText() + " ;;",MachineMode.HEAD_REDUCTION) ;
    }
	
    private final void fullReduction()
    {
	SKWorker.run(skFrame,skCommandTextField.getText() + " ;;",MachineMode.FULL_REDUCTION) ;
    }
	
    private final void oneStepReduction()
    {
	SKWorker.run(skFrame,skCommandTextField.getText() + " ;;",MachineMode.ONE_STEP_REDUCTION) ;
    }

}

