import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.text.* ;
import javax.swing.text.html.* ;
import java.io.* ;
import java.util.* ;

public final class SKHelpFrame extends JFrame
{
    private static SKHelpFrame skHelpFrame = null ;

    public final static void openHelp()
    {
	if (skHelpFrame == null)
	    skHelpFrame = new SKHelpFrame() ;
	skHelpFrame.setVisible(true) ;
    }

    public final static void closeHelp()
    {
	skHelpFrame.setVisible(false) ;
    }

    public static final String getHelpText()
    {
	BufferedReader in  = null ;
	StringWriter   out = new StringWriter() ;
	String         res = null ;

	try {
	    in  = new BufferedReader(new InputStreamReader(SKFrame.class.getResourceAsStream("help.html"))) ;
	    out = new StringWriter() ;

	    String line ;

	    while ((line = in.readLine()) != null) {
		out.write(line) ;
		out.write("\n") ;
	    }

	    out.close() ;
	    res = out.toString() ;
	    in.close() ;
	} catch (Exception e) {
	    e.printStackTrace() ;
	    if (res == null)
		res = "Help not found !" ;
	}

	try { out.close() ; } catch (Exception e) {} ;
	try { in.close() ;  } catch (Exception e) {} ;
	return res ;
    }

    public class SKHelpWindowPanel extends JPanel
    {

	public class SKHelpTextPane extends JEditorPane
	{

	    public SKHelpTextPane()
	    {
		super("text/html",getHelpText()) ;
		setEditable(false) ;
		setCaretPosition(0) ;
	    }
	    
	}

	public SKHelpWindowPanel()
	{
	    setLayout(new BorderLayout()) ;
	    
	    JScrollPane jScrollPane = new JScrollPane(new SKHelpTextPane()) ;
	    jScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	    jScrollPane.setPreferredSize(new Dimension(800,600)) ;
	    add(jScrollPane,BorderLayout.CENTER) ;

	    add(new SKButton("Close",
			     new ActionListener() {
				 public void actionPerformed(ActionEvent e)
				 {
				     closeHelp() ;
				 }}),BorderLayout.SOUTH) ;
	}

    }

    private SKHelpFrame()
    {
	super("SK Machine - Help Page") ;
	setContentPane(new SKHelpWindowPanel()) ;
	pack() ;          

	this.skHelpFrame = skHelpFrame ;
    }

}
