import java.io.* ;

public final class SKList extends SKSymbol
{

    private final SKTerm     last ;
    private final SKSequence skSequence = new SKSequence() ;
    
    public SKList()
    {
	this(null) ;
	
    }

    public SKList(SKTerm last)
    {
	super("@#!?*+=[](){}'") ;
	this.last = last ;
    }

    public final void writeTo(Writer writer)
	throws Exception
    {
	if (skSequence.last == 0 && last == null) {
	    writer.write("NIL") ;
	    return ;
	}

	writer.write("[") ;

	skSequence.writeTo(writer) ;

	if (last != null && last != SKBuilder.getSymbol("NIL")) {
	    writer.write(" . ") ;
	    last.writeTo(writer) ;
	}

	writer.write("]") ;
    }

    public final void add(SKTerm term)
    {
	skSequence.add(term) ;
    }

    public SKList isCdr()
    {
	return this ;
    }

    public SKList isList()
    {
	return this ;
    }
    public boolean isSuccessor()
    {
	return false ;
    }

    public boolean isB()
    {
	return false ;
    }

    public boolean isNumber()
    {
	return false ;
    }

    public boolean isKI()
    {
	return false ;
    }

    public boolean isW()
    {
	return false ;
    }

    public boolean isC()
    {
	return false ;
    }

}