import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

public class SKMenuBar extends JMenuBar
{
    private final SKFrame   skFrame ;
    private final JMenuItem openMenuItem ;
    private final JMenuItem emptyWorkspaceMenuItem ;
    private final JMenuItem quitMenuItem ;
    
    public SKMenuBar(SKFrame _skFrame)
    {
	this.skFrame = _skFrame ;

	JMenu     fileMenu ;
	JMenuItem menuItem ;

	{
	    fileMenu = new JMenu("File") ;

	    fileMenu.add(openMenuItem = new JMenuItem("Open...")) ;
	    openMenuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			skFrame.open() ;
		    }
		}) ;
				       
	    fileMenu.add(menuItem = new JMenuItem("Save")) ;
	    menuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			skFrame.save() ;
		    }
		}) ;
				       
	    fileMenu.add(menuItem = new JMenuItem("Save as...")) ;
	    menuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			skFrame.saveAs() ;
		    }
		}) ;
				       
	    fileMenu.add(quitMenuItem = new JMenuItem("Quit")) ;
	    quitMenuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			skFrame.quit() ;
		    }
		}) ;
				       
	    add(fileMenu) ;
	}

	{
	    fileMenu = new JMenu("Workspace") ;

	    fileMenu.add(emptyWorkspaceMenuItem = new JMenuItem("Empty workspace")) ;
	    emptyWorkspaceMenuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			skFrame.emptyWorkspace() ;
		    }
		}) ;
				       
	    fileMenu.add(menuItem = new JMenuItem("Save workspace")) ;
	    menuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			skFrame.saveWorkspace() ;
		    }
		}) ;
				       				       
	    fileMenu.add(menuItem = new JMenuItem("Nodes count")) ;
	    menuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			JOptionPane.showMessageDialog(skFrame,
						      "JSKI Workspace nodes count: " + SKBuilder.nodeCount(),
						      "JSKI Workspace",
						      JOptionPane.INFORMATION_MESSAGE,
						      SKUtils.messageIcon) ;
		    }
		}) ;
				       				       
	    add(fileMenu) ;
	}
	{
	    fileMenu = new JMenu("Help") ;

	    fileMenu.add(menuItem = new JMenuItem("About")) ;
	    menuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			skFrame.about() ;
		    }
		}) ;
				       
	    fileMenu.add(menuItem = new JMenuItem("Help")) ;
	    menuItem.addActionListener(new ActionListener()
		{
		    public void actionPerformed(ActionEvent e) 
		    {
			SKHelpFrame.openHelp() ;
		    }
		}) ;
				       				       
				       				       
	    add(fileMenu) ;
	}
    }

    public final void setRunning(boolean running)
    {
	boolean notRunning = !running ;

	openMenuItem           .setEnabled(notRunning) ;
	emptyWorkspaceMenuItem .setEnabled(notRunning) ;
	quitMenuItem           .setEnabled(notRunning) ;
    }

}
