import java.io.* ;
import java.util.* ;

public final class SKSequence
{
    private int size ;
    public int last ;

    public final int getLast() { return last ; }

    private final int sizeIncrement ;

    private SKTerm[] table ;

    public SKSequence()
    {
	this.size          = 128 ;
	this.last          = 0 ;
	this.sizeIncrement = 1024 ;
	this.table         = new SKTerm[128] ;
    }

    public SKSequence(SKTerm skTerm)
    {
	this() ;
	add(skTerm) ;
    }

    public final void add(SKTerm val)
    {
	if (last == size)
	    table = Arrays.copyOf(table,size += sizeIncrement) ;

	table[last++] = val ;
    }

    public final SKTerm get(int idx)
    {
	return table[idx] ;
    }

    public final void writeTo(Writer writer)
	throws Exception
    {
	int count = last ;

	if (last > 0) {
	    last-- ;

	    table[last].writeTo(writer) ;
	
	    while (--last >= 0) {
		writer.write(" , ") ;
		table[last].writeTo(writer) ;
	    }
	    return ;
	} 

	writer.write("NIL") ;
    }

}
