import java.io.* ;

public class SKSymbol extends SKAtom
{
    public final String name ;
    public       SKTerm value ;

    public SKSymbol(String name) 
    {
	this.name = name ;
    }

    public final String getName()
    {
	return name ;
    }

    public final void setValue(SKTerm value)
    {
	this.value = value ;
    }

    public final void processArobases()
    {
	if (value != null)
	    value = value.elimArobases() ;
    }
    private final SKApplication Kx = new SKApplication(CombinatorK.unique,this) ;

    public final SKTerm abstractPlus(SKSymbol x)
    {
	return (x == this)  ?  SKBuilder.I : Kx ;
    }

    public final SKTerm abstractPlusPlus(SKSymbol x)
    {
	return (x == this)  ?  SKBuilder.I : Kx ;
    }

    public final SKTerm abstractPlusPlusPlus(SKSymbol x)
    {
	return (x == this)  ?  SKBuilder.I : Kx ;
    }

    public final SKTerm abstractPlusPlusPlusPlus(SKSymbol x)
    {
	return (x == this)  ?  SKBuilder.I : Kx ;
    }

    public boolean freeOf(SKSymbol x)
    {
	return (x != this) ;
    }

    public final void writeDefinition(Writer writer)
	throws Exception
    {
	if (value != null) {
	    writer.write("#DEF ") ;
	    writer.write(name) ;
	    writer.write(" = ") ;
	    value.writeTo(writer) ;
	    writer.write(" ;;\n\n") ;
	} 
    }

    public void writeTo(Writer writer)
	throws Exception
    {
	writer.write(name) ;
    }

    public boolean operate()
    {
	if (value != null) {

	    SKMachine.skRegister.function = value ;

	    SKMachine.reductionCount++ ;
	    return true ;
	}

	return false ;
    }

    public final SKTerm getValue()
    {
	if (value != null)
	    return value ;
	return this ;
    }

    public boolean isSuccessor()
    {
	return name.equals("1+") ;
    }

    public boolean isB()
    {
	return name.equals("B") ;
    }

    public boolean isNumber()
    {
	if (isKI())
	    return true ;

	try {
	    Integer.parseInt(name) ;
	    return true ;
	} catch (Exception e) {}

	return false ;
    }

    public int numberValue()
    {
	try {
	    return Integer.parseInt(name) ;
	} catch (Exception e) {}
	return 0 ;
    }

    public boolean isKI()
    {
	return name.equals("0") || name.equals("FALSE") || name.equals("NIL") ;
    }

    public boolean isW()
    {
	return name.equals("W") ;
    }

    public boolean isC()
    {
	return name.equals("C") ;
    }

    public SKList isList()
    {
	if (name.equals("NIL"))
	    return new SKList() ;
	return null ;
    }

    public SKList isCdr()
    {
	if (name.equals("NIL"))
	    return new SKList() ;
	return null ;
    }

}
