import java.io.* ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

public final class SKUtils
{
    public final static Toolkit toolkit = Toolkit.getDefaultToolkit() ;

    public static final void beep()
    {
	toolkit.beep() ;
    }

    public static final int  fontSize ;
    public static final Font monoFont ;

    static {
	Font defaultFont = UIManager.getFont("TabbedPane.font") ;
	
	fontSize = defaultFont.getSize() ;
	monoFont = new Font(Font.MONOSPACED,Font.PLAIN,fontSize) ;
    }

    public final static String getFileNameExtension(File file)
    {
	return getFileNameExtension(file.getName()) ;
    }

    public final static String getFileNameExtension(String fileName)
    {
	int dot = fileName.lastIndexOf('.') ;
	if (dot >= 0)
	    return fileName.substring(dot+1) ;
	return null ;
    }

    public static final ImageIcon dynamicIcon ;
    static {
	ImageIcon tmpIcon = new ImageIcon(ClassLoader.getSystemResource("dynamic.gif")) ;
	Image     oImage  = tmpIcon.getImage() ;
	int       size    = 2 * fontSize ;
	Image     nImage  = oImage.getScaledInstance(size,size,Image.SCALE_DEFAULT) ;

	dynamicIcon = new ImageIcon(nImage) ;
    }
	
    public static final ImageIcon staticIcon ;
    static {
	ImageIcon tmpIcon = new ImageIcon(ClassLoader.getSystemResource("static.gif")) ;
	Image     oImage  = tmpIcon.getImage() ;
	int       size    = 2 * fontSize ;
	Image     nImage  = oImage.getScaledInstance(size,size,Image.SCALE_SMOOTH) ;

	staticIcon = new ImageIcon(nImage) ;
    }

    public static final ImageIcon messageIcon ;
    static {
	ImageIcon tmpIcon = new ImageIcon(ClassLoader.getSystemResource("static.gif")) ;
	Image     oImage  = tmpIcon.getImage() ;
	int       size    = 5 * fontSize ;
	Image     nImage  = oImage.getScaledInstance(size,size,Image.SCALE_SMOOTH) ;

	messageIcon = new ImageIcon(nImage) ;
    }

    public static final ImageIcon fileStaticIcon ;
    static {
	ImageIcon tmpIcon = new ImageIcon(ClassLoader.getSystemResource("static.gif")) ;
	Icon      fIcon   = UIManager.getIcon("FileView.fileIcon");
	Image     oImage  = tmpIcon.getImage() ;
	int       size    = fontSize ;
	Image     nImage  = oImage.getScaledInstance(fIcon.getIconWidth(),fIcon.getIconHeight(),Image.SCALE_SMOOTH) ;

	fileStaticIcon = new ImageIcon(nImage) ;
    }
}
