import java.awt.* ;
import javax.swing.* ;

public final class SKWindowPanel extends JPanel
{
    private final SKPredefineds   skPredefineds   ;
    private final SKProgramEditor skProgramEditor ;
    private final SKCommandEditor skCommandEditor ;
    private final SKResultDisplay skResultDisplay ;

    private final void addComponent(JComponent jc, double weighty, GridBagLayout gl, GridBagConstraints gc)
    {
	gc.weighty = weighty ;
	gl.setConstraints(jc,gc) ;
	add(jc) ;
    }

    public SKWindowPanel(SKFrame skFrame)
    {
	GridBagLayout gridBagLayout = new GridBagLayout() ;
	setLayout(gridBagLayout) ;

	GridBagConstraints gridBagConstraints = new GridBagConstraints();
	gridBagConstraints.weightx = 1.0 ;
	gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER ;
	gridBagConstraints.gridheight = 1 ;
	gridBagConstraints.fill = GridBagConstraints.BOTH ;

	addComponent(skPredefineds   = new SKPredefineds(),          0.0, gridBagLayout,gridBagConstraints) ;
	addComponent(skProgramEditor = new SKProgramEditor(skFrame), 9.0, gridBagLayout,gridBagConstraints) ;
	addComponent(skCommandEditor = new SKCommandEditor(skFrame), 0.0, gridBagLayout,gridBagConstraints) ;
	addComponent(skResultDisplay = new SKResultDisplay(skFrame), 4.0, gridBagLayout,gridBagConstraints) ;
    }

    public final void setRunning(boolean running)
    {
	skProgramEditor.setRunning(running) ;
	skCommandEditor.setRunning(running) ;
	skResultDisplay.setRunning(running) ;
    }

    public final void loadDefineds()
    {
	skPredefineds.loadDefineds() ;
    }

    public final void open()
    {
	skProgramEditor.open() ;
    }

    public final void save()
    {
	skProgramEditor.save() ;
    }

    public final void saveAs()
    {
	skProgramEditor.saveAs() ;
    }

    public final void emptyWorkspace()
    {
	skProgramEditor.emptyWorkspace() ;
    }

    public final void saveWorkspace()
    {
	skProgramEditor.saveWorkspace() ;
    }

    public final void displayResult(long duration, SKTerm term, long reductionCount)
    {
	skResultDisplay.displayResult(duration,term,reductionCount) ;
    }

    public final int quit()
    {
	return skProgramEditor.quit() ;
    }

}