import java.io.* ;
import java.util.* ;
import javax.swing.* ;

public final class SKWorker extends SwingWorker<Integer,SKWorkerEvent>
{
    public static void run(SKFrame skFrame, String text, int mode)
    {
	new SKWorker(skFrame,text,mode).execute() ;
    }

    public final SKFrame skFrame ;
    public       String  text ;
    public final int     mode ;

    public SKWorker(SKFrame skFrame, String text, int mode)
    {
	this.skFrame = skFrame ;
	this.text    = text ;
	this.mode    = mode ;
    }

    public Integer doInBackground()
    {
	while (text.startsWith(" "))
	    text = text.substring(1) ;

	if (text.length() == 0)
	    return new Integer(0) ;

	try {
	    SKMachine.reductionCount = 0L ;
	    SKMachine.mustFullContinue = true ;
	    SKMachine.skAuxStack.reset() ;
	    SKMachine.run(this,text,mode) ;
	} catch (Throwable e) {
	    skPublish(new SKWorkerEvent(SKWorkerEvent.DISPLAY_ERROR, e.getMessage())) ;
	    e.printStackTrace() ;
	}
	return new Integer(0) ;
    }

    public void done()
    {}

    public void skPublish(SKWorkerEvent event)
    {
	publish(event) ;
    }

    public final void setRunning(boolean running)
    {
	skFrame.setRunning(running) ;
    }

    protected void process(List<SKWorkerEvent> events)
    {
	for (SKWorkerEvent event : events) {
	    switch (event.eventCode) {
	    case SKWorkerEvent.FRAME_SET_RUNNING:
		setRunning(true) ;
		break ;
	    case SKWorkerEvent.FRAME_SET_NOT_RUNNING:
		setRunning(false) ;
		break ;
	    case SKWorkerEvent.DISPLAY_RESULT:
		try {
		    skFrame.displayResult(event.duration,event.result,event.reductionCount) ;
		} catch (Throwable e) {
		    JOptionPane.showMessageDialog(skFrame,
					  "Error: " + event.error + "\nDisplay term aborted",
					  "Display term aborted",
					  JOptionPane.ERROR_MESSAGE,
					  SKUtils.messageIcon) ;
		    skFrame.setRunning(false) ;
		    e.printStackTrace() ;
		}
		break ;
	    case SKWorkerEvent.DISPLAY_ERROR:
		JOptionPane.showMessageDialog(skFrame,
					  "Error: " + event.error + "\nExecution aborted",
					  "Execution aborted",
					  JOptionPane.ERROR_MESSAGE,
					  SKUtils.messageIcon) ;
		break ;

	    }
	}
    } ;

}
